package com.everydayflash.exp.blender {
	import away3d.containers.View3D;
	import away3d.core.base.Mesh;
	import away3d.core.base.Object3D;
	import away3d.core.math.Number3D;
	import away3d.loaders.Obj;
	import away3d.materials.BitmapMaterial;
	
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	import flash.display.Sprite;
	import flash.display.StageAlign;
	import flash.display.StageQuality;
	import flash.display.StageScaleMode;
	import flash.events.Event;	

	/**
	 * @author Bartek Drozdz
	 * 		   http://www.everydayflash.com
	 */
	public class BakedChair extends Sprite {

		private var view:View3D;

		[Embed(source="model.obj",mimeType="application/octet-stream")]
        private var BlenderMesh:Class;
        private var obj:Obj;
        
        [Embed (source="material.jpg")]
        private var BakedMaterial:Class;

		private var bakedMat:BitmapMaterial;

		public function BakedChair() {
			stage.quality = StageQuality.MEDIUM;
			stage.scaleMode = StageScaleMode.NO_SCALE;
			stage.align = StageAlign.TOP_LEFT;
			
			initEngine();
			initObjects();
			initListeners();
		}

		private function initEngine():void {
			view = new View3D();
			view.camera.zoom = 6;
			view.camera.focus = 200;
			view.camera.lookAt(new Number3D());
			addChild(view);
		}

		private function initObjects():void {
			obj = new Obj(new BlenderMesh());
			obj.mesh.scale(10);
			
			var bmp:BitmapData = (new BakedMaterial() as Bitmap).bitmapData;
			bakedMat = new BitmapMaterial(bmp);

			obj.mesh.material = bakedMat;
			view.scene.addChild(obj.mesh);
		}

		private function initListeners():void {
			addEventListener(Event.ENTER_FRAME, render);
		}

		private function render(event:Event):void {
			view.render();
		}
	}
}
